#include <string.h>
#include <wiringPi.h>

#include "control.h"
#include "brightness.h"
#include "color.h"
#include "mbi5026.h"

void color_set_frame(struct data_color* data, struct frame* frame) {
	for (int i = 0; i<LEDS; i++) {
		for (int c = 0; c<COLUMNS; c++) {
			struct led* led = &frame->columns[c].leds[i];
			led->red = data->red;
			led->green = data->green;
			led->blue = data->blue;
		}
	}
}

void color(struct data_color* data) {
	struct message message;
	struct frame frame;

	color_set_frame(data, &frame);

	for (;;) {
		mbi_write_frame_pwm(&frame, 4);

		if (control_read(&message)) {
			switch (message.type) {
			case T_RESET:
				memset(&frame, 0, sizeof(frame));
				mbi_write_frame(&frame);
				return;
			case T_BRIGHTNESS:
				brightness(&message.data.brightness);
				break;
			case T_COLOR:
				color_set_frame(&message.data.color, &frame);
				break;
			default:
				break;
			}
		}
	}
}
