/*
 * control.h
 *
 *  Created on: Jul 10, 2016
 *      Author: slash
 */

#ifndef CONTROL_H_
#define CONTROL_H_

typedef enum {
	T_RESET,
	T_BRIGHTNESS,
	T_COLOR,
	T_TIMER,
	T_LAVA
} type;

typedef enum {
	C_NULL,
	C_START,
	C_PAUSE,
	C_CONTINUE
} command;


// ---

struct data_brightness {
	int value;
};

// ---

struct data_color {
	int red;
	int green;
	int blue;
};

// ---

struct data_timer {
	command command;
	int seconds;
};

// ---

typedef enum {
	L_START,
	L_ADD_DOT,
	L_UPDATE_DOT,
	L_REMOVE_DOT
} lava_command;

struct data_lava_dot {
	int id;
	int size;
	int red;
	int green;
	int blue;
	int period;
	int cursor;
	int segments;
};

struct data_lava {
	lava_command lava_command;
	struct data_lava_dot dot;
};

// ---

struct message {
	type type;
	union {
		struct data_brightness brightness;
		struct data_color color;
		struct data_timer timer;
		struct data_lava lava;
	} data;
};

// ---

void control_init();
int control_read(struct message* message);
int control_read_timeout(struct message* message, int timeout_millis);
void control_read_blocking(struct message* message);
void control_close();

#endif /* CONTROL_H_ */
