#include "frame.h"

inline void add_value(int value1, int value2, int* sum) {
	int sum_ = value1 + value2;
	if (sum_ > MAX_VALUE) {
		sum_ = MAX_VALUE;
	}

	*sum = sum_;
}

inline void add_led(struct led* led1, struct led* led2, struct led* sum) {
	add_value(led1->red, led2->red, &sum->red);
	add_value(led1->green, led2->green, &sum->green);
	add_value(led1->blue, led2->blue, &sum->blue);
}

inline void add_column(struct column* column1, struct column* column2, struct column* sum) {
	for (int i=0; i<LEDS; i++) {
		add_led(&column1->leds[i], &column2->leds[i], &sum->leds[i]);
	}
}

void add_frames(struct frame* frame1, struct frame* frame2, struct frame* sum) {
	for (int i=0; i<COLUMNS; i++) {
		add_column(&frame1->columns[i], &frame2->columns[i], &sum->columns[i]);
	}
}
