#include <math.h>

#include "options.h"
#include "debug.h"
#include "mbi5026.h"
#include "control.h"
#include "brightness.h"
#include "color.h"
#include "timer.h"
#include "lava.h"

int main(int argc, char* const argv[]) {
	options_init(argc, argv);
	mbi_init();
	control_init();

	for (;;) {
		struct message message;
		control_read_blocking(&message);

		switch (message.type) {
		case T_BRIGHTNESS:
			debug_log("main: brightness\n");
			brightness(&message.data.brightness);
			break;
		case T_COLOR:
			debug_log("main: color\n");
			color(&message.data.color);
			break;
		case T_TIMER:
			debug_log("main: timer\n");
			timer(&message.data.timer);
			break;
		case T_LAVA:
			debug_log("main: lava\n");
			lava(&message.data.lava);
			break;
		case T_RESET:
			break;
		}
	}

	control_close();
}

