#ifndef MBI5026_H_
#define MBI5026_H_

#include "frame.h"

extern int PIN_SDI[];
#define PIN_CLK 24
#define PIN_LE  23

#define PIN_PWM 18

// Delay and widen the pulse by starting with 0, then a double-1, then 0 again.
// This (+ connecting all CLK pins together + a 56 Ohm resistor) reduces pretty much all glitching artifacts
// that can be seen in RGB mode when having a low blue (or red) value and brightness set to 1/2.
#define pulse(PIN) digitalWrite(PIN, 0); digitalWrite(PIN, 1); digitalWrite(PIN, 1); digitalWrite(PIN, 0);

void mbi_init();

void mbi_write_frame(struct frame* frame);

void mbi_write_frame_pwm(struct frame* frame, int loops);

#endif /* MBI5026_H_ */
