#include <stdlib.h>
#include <stdio.h>

// to enable the timersub() macro
#define __USE_BSD

#include "util.h"

void util_gettimeofday(struct timeval* tv) {
	int rc = gettimeofday(tv, NULL);
	if (rc != 0) {
		perror("Error calling gettimeofday()");
		exit(EXIT_FAILURE);
	}
}

void util_millis_to_timeval(int millis, struct timeval* tv) {
	tv->tv_sec = millis / 1000;
	tv->tv_usec = (millis % 1000) * 1000;
}

int util_timeval_to_millis(struct timeval* tv) {
	return (tv->tv_sec * 1000) + (tv->tv_usec / 1000);
}

int util_get_elapsed_millis_since(struct timeval* begin) {
	struct timeval current;
	util_gettimeofday(&current);

	struct timeval elapsed;
	timersub(&current, begin, &elapsed);

	return util_timeval_to_millis(&elapsed);
}
